package ee.config;

public class Config {
	
	// PATHS
	
	public static final String PATHS_STOPWORDSFILE = "ee/data/utilities/stopwords.txt";
	
	//public static final String PATHS_RAW_LOG_PATH = "data/input";
	public static final String PATHS_RAW_LOG_PATH = "/home/oyvine/rawlogs";
	public static final String PATHS_PREPROCESSES_RAW_LOG_PATH = "data/preprocessed";
	public static final String PATHS_PROCESSED_OUTPUT = "data/output";
	
	// PREPROCESSING RAWLOGS

	public static final boolean PREPROCESSING_RAW_LOG_RSS = false;
	public static final boolean PREPROCESSING_RAW_LOG_USNS = false;
	public static final boolean PREPROCESSING_RAW_LOG_SEARCH = true;
	public static final boolean PREPROCESSING_RAW_LOG_ALL = false;
	public static final int PREPROCESSING_MAX_CHARACTERS = 50;
	public static final int PREPROCESSING_MAX_TERMS = 8;
	
	// SESSIONS
	
	public static final int SESSIONS_SESSION_TIME_FRAME = 300;
	public static final int SESSIONS_NUMBER_OF_QUERY_REFINEMENTS = 10;
	public static final boolean SESSIONS_OVERLAPPING_TERMS = true;
	
	//  CORRELATION
	
	public static int CORRELATION_TIME_UNIT = 1;
	public static int CORRELATION_TIME_DURATION = 24;
	public static int CORRELATION_SKIP_FROM_START = 0;
	
	public static int CORRELATION_MINIMUM_TOTAL_FREQUENCY = 25;
	public static int CORRELATION_MINIMUM_SESSION_QUERY_FREQUENCIES = 5;
	public static int CORRELATION_NUMBER_OF_MAX_ZERO_FREQUENCIES = 10;
	public static final float CORRELATION_COEFFICIENT = 0.5f;
	
	// DECOMPOSITION
	
	public static final int DECOMPOSITION_MINIMUM_PHRASE_FREQUENCY = 2;
	public static final int DECOMPOSITION_MINIMUM_COMPOUND_FREQUENCY = 2;

	public static final int DECOMPOSITION_CONNECITY_MAX_TERM_FREQUENCY = 4;
	public static final int DECOMPOSITION_MINIMUM_TOKEN_LOG_FREQUENCY = 10;
	
	public static void setCorrelationParameters(int timeDuration, int timeUnit, int skipFromStart, int NumberOfMaxZeroFrequencies, int minimumTotalFrequency, int sessionFrequencies){
		CORRELATION_TIME_DURATION = timeDuration;
		CORRELATION_TIME_UNIT = timeUnit;
		CORRELATION_SKIP_FROM_START = skipFromStart;
		CORRELATION_NUMBER_OF_MAX_ZERO_FREQUENCIES = NumberOfMaxZeroFrequencies;
		CORRELATION_MINIMUM_TOTAL_FREQUENCY = minimumTotalFrequency;
		CORRELATION_MINIMUM_SESSION_QUERY_FREQUENCIES = sessionFrequencies;
	}
	
	public static String createFileInfoString(){
		return CORRELATION_TIME_DURATION + "-" + CORRELATION_TIME_UNIT + "-" + CORRELATION_SKIP_FROM_START + "-" + CORRELATION_NUMBER_OF_MAX_ZERO_FREQUENCIES + "-" + CORRELATION_MINIMUM_TOTAL_FREQUENCY + "-" + CORRELATION_MINIMUM_SESSION_QUERY_FREQUENCIES; 
	}
}
