package ee.decomposition;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import ee.config.Config;
import ee.input.preprocessing.FilePreprocessing;

public class Phrases {
	private HashMap phraseMap;
	private File outputFile;
	private int numberOfPhrases;
	
	
	public Phrases(){
		phraseMap = new HashMap();
		outputFile = new File(Config.PATHS_PROCESSED_OUTPUT, "phrases");
	}
	
	public void addPhrase(String input){
		String temp = input;
		
		boolean done = false;
		while(!done){
			int indexStart = -1;
			if((indexStart = temp.indexOf(34)) >= 0){
				int indexStop = -1;
				if((indexStop = temp.indexOf(34, indexStart + 1)) >= 0){
					String phrase = temp.substring(indexStart +1, indexStop).trim();
					temp = temp.substring(indexStop + 1, temp.length());
					
					if(!(phrase.indexOf(32) >= 0)){
						continue;
					}
					numberOfPhrases++;
					
					if(phraseMap.containsKey(phrase)){
						phraseMap.put(phrase, new Integer(((Integer)phraseMap.get(phrase)).intValue()+ 1));
					} else {
						phraseMap.put(phrase, new Integer(1));
					}
				} else {
					done = true;
				}
			} else {
				done = true;
			}
		}
	}
	
	public void writePhraseMap() throws IOException{
		FilePreprocessing.simpleQueryFrequencyToFile(phraseMap, outputFile, numberOfPhrases);
	}
}
