package ee.input.preprocessing;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

import ee.config.Config;
import ee.input.file.FileFinder;
import ee.input.file.ReadFile;

public class TotalFrequencyProsessing {
	
	public static void analyzeFrequencyFiles() throws IOException{
		HashMap queryMap = new HashMap();		
		ArrayList files = FileFinder.getAllFiles(Config.PATHS_PREPROCESSES_RAW_LOG_PATH, "frequency_access");
		System.out.println(files.size());
		File outputFile = new File(Config.PATHS_PREPROCESSES_RAW_LOG_PATH, "total_frequency");
		outputFile.getParentFile().mkdirs();
		
		int numberOfQueries = 0;
		
		for(int i = 0; i < files.size(); i++){
			File f = (File)files.get(i);
			
			ReadFile rf = new ReadFile(f);
			
			String tempString = "";
			while((tempString = rf.getNextLine()) != null){
				StringTokenizer st = new StringTokenizer(tempString, "\t");
				if(st.countTokens() == 2){
					int frequency = Integer.parseInt(st.nextToken().trim());
					String query = st.nextToken().trim();
					if(queryMap.containsKey(query)){
						Integer newCount = (Integer)queryMap.get(query);
						queryMap.put(query, new Integer(newCount.intValue() + frequency));
					} else {
						queryMap.put(query, new Integer(frequency));
					}
				} else {
					StringTokenizer st2 = new StringTokenizer(tempString, " ");
					numberOfQueries += Integer.parseInt(st2.nextToken().trim());
					continue;
				}
			}
		}
		
		FilePreprocessing.simpleQueryFrequencyToFile(queryMap, outputFile, numberOfQueries);
		System.out.println(outputFile + " created");
	}
	
	public static void main(String[] args) throws IOException{
		TotalFrequencyProsessing.analyzeFrequencyFiles();
	}
	
}

