package ee.session;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

import ee.config.Config;
import ee.input.file.FileFinder;
import ee.input.file.ReadFile;
import ee.input.preprocessing.FilePreprocessing;

public class FilteredSessionTotalFrequency {

	public static HashMap createTotalFrequencySessionMap() throws IOException{
		HashMap queryMap = new HashMap();		
		ArrayList files = FileFinder.getAllFiles(Config.PATHS_PROCESSED_OUTPUT, "filtered_sessions");
		
		File outputFile = new File(Config.PATHS_PROCESSED_OUTPUT, "filtered_session_total_frequency");
		outputFile.getParentFile().mkdirs();
		
		int numberOfQueries = 0;
		
		for(int i = 0; i < files.size(); i++){
			File f = (File)files.get(i);
			
			ReadFile rf = new ReadFile(f);
			
			String tempString = "";
			while((tempString = rf.getNextLine()) != null){
				StringTokenizer st = new StringTokenizer(tempString, "\t");
				if(st.countTokens() == 3){
					st.nextToken();
					st.nextToken();
					String query = st.nextToken().trim();
					if(queryMap.containsKey(query)){
						Integer newCount = (Integer)queryMap.get(query);
						queryMap.put(query, new Integer(newCount.intValue() + 1));
					} else {
						queryMap.put(query, new Integer(1));
					}
				} else {
					StringTokenizer st2 = new StringTokenizer(tempString, " ");
					numberOfQueries += Integer.parseInt(st2.nextToken().trim());
					continue;
				}
			}
		}
		
		FilePreprocessing.simpleQueryFrequencyToFile(queryMap, outputFile, numberOfQueries);		
		System.out.println(outputFile + " created");
		
		return queryMap;
	}
}