package ee.utilities;

public class Pair<T1, T2> {
	public final T1 first;

	public final T2 second;

	private int hashCode;

	public Pair(T1 first, T2 second) {
		this.first = first;
		this.second = second;
	}

	public static <T1, T2> Pair<T1, T2> make(T1 first, T2 second) {
		return new Pair<T1, T2>(first, second);
	}

	public boolean equals(Object obj) {
		if (!(obj instanceof Pair)) {
			return false;
		}

		Pair other = (Pair) obj;

		return (first == null ? other.first == null : first.equals(other.first))
				&& (second == null ? other.second == null : second
						.equals(other.second));
	}

	public int hashCode() {
		if (hashCode == 0) {
			if (first != null) {
				hashCode += first.hashCode();
			}

			if (second != null) {
				hashCode += second.hashCode();
			}
		}

		return hashCode;
	}
}

