package ee.utilities;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;

import ee.config.Config;

public class StopWords {
	private HashSet hashSet = new HashSet();

	public StopWords() {
		BufferedReader inputStream;
		String line = "";

		try {
			inputStream = new BufferedReader(new FileReader(Config.PATHS_STOPWORDSFILE));

			while ((line = inputStream.readLine()) != null) {
				hashSet.add(line.trim());
			}
			inputStream.close();
		} catch (FileNotFoundException e) {
			System.out.println("Error, file not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("End of file");
			e.printStackTrace();
		}
	}

	public boolean isStopWord(String word) {
		return hashSet.contains(word);
	}

	public static void main(String[] args) {
		StopWords sw = new StopWords();
		System.out.println("er \"the\" et stopword " + sw.isStopWord("the"));
	}
}
